unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ScktComp, StdCtrls, Sockets, ExtCtrls;

type
  TVytah=record
          patro:integer;
          pouzitelne:boolean;
          dalsi:array of integer;
        end;
  TForm1 = class(TForm)
    cs: TClientSocket;
    MainMenu1: TMainMenu;
    Wiew1: TMenuItem;
    special1: TMenuItem;
    connect1: TMenuItem;
    engine1: TMenuItem;
    commandline1: TMenuItem;
    Memo1: TMemo;
    procedure csConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure csDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure connect1Click(Sender: TObject);
    procedure csRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure engine1Click(Sender: TObject);
    procedure TcpCConnect(Sender: TObject);
    procedure TcpCError(Sender: TObject; SocketError: Integer);
    procedure TcpCDisconnect(Sender: TObject);
    procedure TcpCReceive(Sender: TObject; Buf: PAnsiChar;
      var DataLen: Integer);
    procedure commandline1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  vytah:array of TVytah;

implementation

uses Unit2, Unit3;

{$R *.dfm}

procedure kontrolafronty(cislo:integer);
begin
  

end;

procedure TForm1.csConnect(Sender: TObject; Socket: TCustomWinSocket);
begin

  Memo1.Lines.Add('Jsem pipojen');
end;

procedure TForm1.csError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  Memo1.Lines.Add('Chyba ve spojen');
end;

procedure TForm1.csDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin

  Memo1.Lines.Add('Byl jsem odpojen');
end;

procedure TForm1.connect1Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.csRead(Sender: TObject; Socket: TCustomWinSocket);
var
  textik:string;
  cykl,sloupec,patro,vytahu:integer;
begin
  textik:=socket.receivetext;
  Textik:=copy(textik,1,Length(textik)-1);
  Memo1.Lines.Add(textik);

  If pos('opened',textik)=1 then
    begin
      delete(textik,1,6);
      sloupec:=StrToint(trim(textik));
      Form1.cs.socket.SendText('indioff ' + IntToStr(sloupec) + ' ' + IntToStr(vytah[sloupec].patro) + CRLF);
      Form1.Memo1.Lines.Add('indioff ' + IntToStr(sloupec) + ' ' + IntToStr(vytah[sloupec].patro));
      Form1.cs.socket.SendText('close ' + IntToStr(sloupec) + CRLF);
      Exit;
    end;

  If (pos('level ',textik)>0) and not(pos('error',textik)>0) then
    begin
      textik:=copy(textik,pos('level',textik),length(textik)-pos('level',textik));
      delete(textik,1,5);
      textik:=Trim(textik);                                        //oetuje text
      sloupec:=StrToInt(Trim(copy(textik,1,pos(' ',textik))));     //aby se dal pout
      delete(textik,1,pos(' ',textik));                            //i kdy se pole
      patro:=StrToInt(Trim(textik));                               //v trochu jinm formtu
      Form1.cs.socket.sendtext('open ' + IntToStr(sloupec) + CRLF);
      vytah[sloupec].pouzitelne:=false;
      vytah[sloupec].patro:=patro;
      exit;
    end;

  If pos('cabinbutton',textik)=1 then
    begin
      delete(textik,1,11);                                         //Tohle oetuje text
      textik:=Trim(textik);                                        //aby se dal pout
      sloupec:=StrToInt(Trim(copy(textik,1,pos(' ',textik))));     //i kdy se pole v trochu jinm
      If sloupec>Length(vytah)-1 then       //kdy zjist, e se nenaetl poet
        engine1.click;                      //vtah, nate ho znovu
      If vytah[sloupec].pouzitelne=false then
        begin
          setlength(vytah[sloupec].dalsi,length(vytah[sloupec].dalsi)+1);  //Kdy vtah u nco dl
          vytah[sloupec].dalsi[Length(vytah[sloupec].dalsi)-1]:=patro;     //poadavek se zaad do fronty
          exit;
        end;                                                       
      delete(textik,1,pos(' ',textik));
      patro:=StrToInt(Trim(textik));
      Form1.cs.socket.SendText('indion ' + IntToStr(sloupec) + ' ' + IntToStr(patro) + CRLF);
      Form1.cs.socket.SendText('floor ' + IntToStr(sloupec) + ' ' + IntToStr(patro) + CRLF);
      exit;
    end;

  If pos('closed',textik)=1 then
    begin
      Delete(textik,1,6);
      sloupec:=StrToInt(Trim(textik));
      If Length(vytah)-1<sloupec then //zfunkn vtah, kter dojel na sv stanovit
        exit;
      Vytah[sloupec].pouzitelne:=true;
      Kontrolafronty(sloupec);
      Exit;
    end;

  If pos('shafts',textik)=1 then
    begin
      delete(textik,1,6);
      vytahu:=StrToInt(Trim(textik));        //nastavi poet vtah
      SetLength(vytah,vytahu);
      For cykl:=0 to Length(vytah)-1 do
        begin
          vytah[cykl].patro:=0;
          vytah[cykl].pouzitelne:=true;
          setlength(vytah[cykl].dalsi,0);
          Form1.cs.socket.sendtext('close ' + IntToStr(cykl) + CRLF); //zave vechny vtahy
        end;
      Exit;
    end;
end;

procedure TForm1.engine1Click(Sender: TObject);
begin
  cs.socket.sendtext('shafts' + CRLF);
end;

procedure TForm1.TcpCConnect(Sender: TObject);
begin
  Memo1.Lines.Add('Jsem tam');

end;

procedure TForm1.TcpCError(Sender: TObject; SocketError: Integer);
begin
  Memo1.Lines.Add('Chyba ve spojen');
end;

procedure TForm1.TcpCDisconnect(Sender: TObject);
begin
  Memo1.Lines.Add('Disconnect');
end;

procedure TForm1.TcpCReceive(Sender: TObject; Buf: PAnsiChar;
  var DataLen: Integer);
begin
  Memo1.Lines.Add(buf);
end;

procedure TForm1.commandline1Click(Sender: TObject);
begin
  Form3.Show;
end;

end.
